//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Contributors & Maintainers
  SPDX-License-Identifier: MIT
*/
//==================================================================================================
#pragma once

//================================================================================================
//! @addtogroup functions
//! @{
//! @defgroup combinatorial Combinatorial
//!
//! These functions provide scalar and SIMD version of some combinatorial functions.
//!
//! **Convenience header:** @code{.cpp} #include <eve/function/combinatorial.hpp> @endcode
//!
//!@}
//================================================================================================
#include <eve/function/bernouilli.hpp>
#include <eve/function/double_factorial.hpp>
#include <eve/function/factorial.hpp>
#include <eve/function/fibonacci.hpp>
#include <eve/function/gcd.hpp>
#include <eve/function/lcm.hpp>
#include <eve/function/lrising_factorial.hpp>
#include <eve/function/nth_prime.hpp>
#include <eve/function/prime_ceil.hpp>
#include <eve/function/prime_floor.hpp>
#include <eve/function/rising_factorial.hpp>
