//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Contributors & Maintainers
  SPDX-License-Identifier: MIT
*/
//==================================================================================================
#pragma once

//================================================================================================
//! @addtogroup functions
//! @{
//! @defgroup comparisons Comparisons
//!
//! These functions provide scalar and SIMD version of comparison functions.
//!
//! **Convenience header:** @code{.cpp} #include <eve/function/comparison.hpp> @endcode
//!
//!@}
//================================================================================================
#include <eve/function/is_equal.hpp>
#include <eve/function/is_eqz.hpp>
#include <eve/function/is_gez.hpp>
#include <eve/function/is_greater.hpp>
#include <eve/function/is_greater_equal.hpp>
#include <eve/function/is_gtz.hpp>
#include <eve/function/is_less.hpp>
#include <eve/function/is_lessgreater.hpp>
#include <eve/function/is_less_equal.hpp>
#include <eve/function/is_lez.hpp>
#include <eve/function/is_ltz.hpp>
#include <eve/function/is_nez.hpp>
#include <eve/function/is_ngez.hpp>
#include <eve/function/is_not_greater.hpp>
#include <eve/function/is_not_greater_equal.hpp>
#include <eve/function/is_gntz.hpp>
#include <eve/function/is_not_less.hpp>
#include <eve/function/is_not_less_equal.hpp>
#include <eve/function/is_nltz.hpp>
