//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Contributors & Maintainers
  SPDX-License-Identifier: MIT
*/
//==================================================================================================
#pragma once

//================================================================================================
//! @addtogroup functions
//! @{
//! @defgroup exponential Exponential
//!
//! These functions provide scalar and SIMD version of exponential functions.
//!
//! **Convenience header:** @code{.cpp} #include <eve/function/exponentials.hpp> @endcode
//!
//!@}
//================================================================================================

#include <eve/function/exp.hpp>
#include <eve/function/exp10.hpp>
#include <eve/function/exp2.hpp>
#include <eve/function/expm1.hpp>
#include <eve/function/log.hpp>
#include <eve/function/log10.hpp>
#include <eve/function/log2.hpp>
#include <eve/function/log1p.hpp>
