//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Contributors & Maintainers
  SPDX-License-Identifier: MIT
*/
//==================================================================================================
#pragma once

//================================================================================================
//! @addtogroup functions
//! @{
//! @defgroup invtrigonometric Invtrigonometric
//!
//! These functions provide scalar and SIMD version of the inverse trigonometric functions in radians,
//! degrees and \f$\pi\f$ multiples.
//!
//! **Convenience header:** @code{.cpp} #include <eve/function/invtrigonometric.hpp> @endcode
//!
//!@}
//================================================================================================
#include <eve/function/acos.hpp>
#include <eve/function/acosd.hpp>
#include <eve/function/acospi.hpp>
#include <eve/function/acot.hpp>
#include <eve/function/acotd.hpp>
#include <eve/function/acotpi.hpp>
#include <eve/function/acsc.hpp>
#include <eve/function/acscd.hpp>
#include <eve/function/acscpi.hpp>
#include <eve/function/asec.hpp>
#include <eve/function/asecd.hpp>
#include <eve/function/asecpi.hpp>
#include <eve/function/asin.hpp>
#include <eve/function/asind.hpp>
#include <eve/function/asinpi.hpp>
#include <eve/function/atan.hpp>
#include <eve/function/atan2.hpp>
#include <eve/function/atan2d.hpp>
#include <eve/function/atan2pi.hpp>
#include <eve/function/atand.hpp>
#include <eve/function/atanpi.hpp>
#include <eve/function/radindeg.hpp>
