//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Contributors & Maintainers
  SPDX-License-Identifier: MIT
*/
//==================================================================================================
#pragma once

//================================================================================================
//! @addtogroup functions
//! @{
//! @defgroup polynomial Polynomial
//!
//! These functions provide scalar and SIMD version of polynomial evaluation functions.
//!
//! **Convenience header:** @code{.cpp} #include <eve/function/polynomial.hpp> @endcode
//!
//!@}
//================================================================================================

#include <eve/function/gegenbauer.hpp>
#include <eve/function/hermite.hpp>
#include <eve/function/horner.hpp>
#include <eve/function/laguerre.hpp>
#include <eve/function/legendre.hpp>
#include <eve/function/newton.hpp>
