//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Contributors & Maintainers
  SPDX-License-Identifier: MIT
*/
//==================================================================================================
#pragma once

//================================================================================================
//! @addtogroup functions
//! @{
//! @defgroup proba Proba
//!
//! These functions provide scalar and SIMD version of proba distribution functions.
//!
//! **Convenience header:** @code{.cpp} #include <eve/function/proba.hpp> @endcode
//!
//!@}
//================================================================================================

#include <eve/function/binomial_distribution.hpp>
#include <eve/function/cauchy_distribution.hpp>
#include <eve/function/exponential_distribution.hpp>
#include <eve/function/exponential.hpp>
#include <eve/function/lognormal_distribution.hpp>
#include <eve/function/normal_distribution.hpp>
#include <eve/function/poisson_distribution.hpp>
#include <eve/function/uniform_continuous_distribution.hpp>
#include <eve/function/uniform_discrete_distribution.hpp>
