//==================================================================================================
/*
  EVE - Expressive Vector Engine
  Copyright : EVE Contributors & Maintainers
  SPDX-License-Identifier: MIT
*/
//==================================================================================================
#pragma once

//================================================================================================
//! @addtogroup functions
//! @{
//! @defgroup special Special
//!
//! These functions provide scalar and SIMD version of special functions.
//!
//! **Convenience header:** @code{.cpp} #include <eve/function/special.hpp> @endcode
//!
//!@}
//================================================================================================
#include <eve/function/beta.hpp>
#include <eve/function/betainc.hpp>
#include <eve/function/betainc_inv.hpp>
#include <eve/function/dawson.hpp>
#include <eve/function/digamma.hpp>
#include <eve/function/erfc.hpp>
#include <eve/function/erfc_inv.hpp>
#include <eve/function/erfcx.hpp>
#include <eve/function/erf.hpp>
#include <eve/function/erf_inv.hpp>
#include <eve/function/exp_int.hpp>
#include <eve/function/gamma_p.hpp>
#include <eve/function/gamma_p_inv.hpp>
#include <eve/function/lbeta.hpp>
#include <eve/function/lgamma.hpp>
#include <eve/function/signgam.hpp>
#include <eve/function/stirling.hpp>
#include <eve/function/tgamma.hpp>
#include <eve/function/zeta.hpp>
