#include <eve/function/pedantic/ffs.hpp>
#include <eve/wide.hpp>
#include <iostream>

using wide_it = eve::wide<std::uint32_t, eve::fixed<8>>;

int main()
{
  wide_it pi = {14, 1, 3, 7, 20, 23000, 0, 27};

  std::cout << "---- simd" << '\n'
            << "<- pi                = " << pi << '\n'
            << "-> ffs(pi)           = " << eve::ffs(pi) << '\n'
            << "-> pedantic(fls)(pi) = " << eve::pedantic(eve::ffs)(pi) << '\n';

  std::uint32_t xf = 48;

  std::cout << "---- scalar" << '\n'
            << "<- xf              = " << xf << '\n'
            << "-> ffs(xf) = " << eve::ffs(xf) << '\n';
  return 0;
}
